Index: rtos_arduino/trunk/arduino_lib/libraries/Firmata/utility/SerialFirmata.cpp
===================================================================
--- rtos_arduino/trunk/arduino_lib/libraries/Firmata/utility/SerialFirmata.cpp	(revision 224)
+++ rtos_arduino/trunk/arduino_lib/libraries/Firmata/utility/SerialFirmata.cpp	(revision 224)
@@ -0,0 +1,328 @@
+/*
+  SerialFirmata.cpp
+  Copyright (C) 2016 Jeff Hoefs. All rights reserved.
+
+  This library is free software; you can redistribute it and/or
+  modify it under the terms of the GNU Lesser General Public
+  License as published by the Free Software Foundation; either
+  version 2.1 of the License, or (at your option) any later version.
+
+  See file LICENSE.txt for further informations on licensing terms.
+
+  This version of SerialFirmata.cpp differs from the ConfigurableFirmata
+  version in the following ways:
+
+  - handlePinMode calls Firmata::setPinMode
+
+  Last updated by Jeff Hoefs: January 10th, 2016
+*/
+
+#include "SerialFirmata.h"
+
+SerialFirmata::SerialFirmata()
+{
+  swSerial0 = NULL;
+  swSerial1 = NULL;
+  swSerial2 = NULL;
+  swSerial3 = NULL;
+
+  serialIndex = -1;
+}
+
+boolean SerialFirmata::handlePinMode(byte pin, int mode)
+{
+  // used for both HW and SW serial
+  if (mode == PIN_MODE_SERIAL) {
+    Firmata.setPinMode(pin, PIN_MODE_SERIAL);
+    return true;
+  }
+  return false;
+}
+
+void SerialFirmata::handleCapability(byte pin)
+{
+  if (IS_PIN_SERIAL(pin)) {
+    Firmata.write(PIN_MODE_SERIAL);
+    Firmata.write(getSerialPinType(pin));
+  }
+}
+
+boolean SerialFirmata::handleSysex(byte command, byte argc, byte *argv)
+{
+  if (command == SERIAL_MESSAGE) {
+
+    Stream *serialPort;
+    byte mode = argv[0] & SERIAL_MODE_MASK;
+    byte portId = argv[0] & SERIAL_PORT_ID_MASK;
+
+    switch (mode) {
+      case SERIAL_CONFIG:
+        {
+          long baud = (long)argv[1] | ((long)argv[2] << 7) | ((long)argv[3] << 14);
+          serial_pins pins;
+
+          if (portId < 8) {
+            serialPort = getPortFromId(portId);
+            if (serialPort != NULL) {
+              pins = getSerialPinNumbers(portId);
+              if (pins.rx != 0 && pins.tx != 0) {
+                Firmata.setPinMode(pins.rx, PIN_MODE_SERIAL);
+                Firmata.setPinMode(pins.tx, PIN_MODE_SERIAL);
+                // Fixes an issue where some serial devices would not work properly with Arduino Due
+                // because all Arduino pins are set to OUTPUT by default in StandardFirmata.
+                pinMode(pins.rx, INPUT);
+              }
+              ((HardwareSerial*)serialPort)->begin(baud);
+            }
+          } else {
+#if defined(SoftwareSerial_h)
+            byte swTxPin, swRxPin;
+            if (argc > 4) {
+              swRxPin = argv[4];
+              swTxPin = argv[5];
+            } else {
+              // RX and TX pins must be specified when using SW serial
+              Firmata.sendString("Specify serial RX and TX pins");
+              return false;
+            }
+            switch (portId) {
+              case SW_SERIAL0:
+                if (swSerial0 == NULL) {
+                  swSerial0 = new SoftwareSerial(swRxPin, swTxPin);
+                }
+                break;
+              case SW_SERIAL1:
+                if (swSerial1 == NULL) {
+                  swSerial1 = new SoftwareSerial(swRxPin, swTxPin);
+                }
+                break;
+              case SW_SERIAL2:
+                if (swSerial2 == NULL) {
+                  swSerial2 = new SoftwareSerial(swRxPin, swTxPin);
+                }
+                break;
+              case SW_SERIAL3:
+                if (swSerial3 == NULL) {
+                  swSerial3 = new SoftwareSerial(swRxPin, swTxPin);
+                }
+                break;
+            }
+            serialPort = getPortFromId(portId);
+            if (serialPort != NULL) {
+              Firmata.setPinMode(swRxPin, PIN_MODE_SERIAL);
+              Firmata.setPinMode(swTxPin, PIN_MODE_SERIAL);
+              ((SoftwareSerial*)serialPort)->begin(baud);
+            }
+#endif
+          }
+          break; // SERIAL_CONFIG
+        }
+      case SERIAL_WRITE:
+        {
+          byte data;
+          serialPort = getPortFromId(portId);
+          if (serialPort == NULL) {
+            break;
+          }
+          for (byte i = 1; i < argc; i += 2) {
+            data = argv[i] + (argv[i + 1] << 7);
+            serialPort->write(data);
+          }
+          break; // SERIAL_WRITE
+        }
+      case SERIAL_READ:
+        if (argv[1] == SERIAL_READ_CONTINUOUSLY) {
+          if (serialIndex + 1 >= MAX_SERIAL_PORTS) {
+            break;
+          }
+
+          if (argc > 2) {
+            // maximum number of bytes to read from buffer per iteration of loop()
+            serialBytesToRead[portId] = (int)argv[2] | ((int)argv[3] << 7);
+          } else {
+            // read all available bytes per iteration of loop()
+            serialBytesToRead[portId] = 0;
+          }
+          serialIndex++;
+          reportSerial[serialIndex] = portId;
+        } else if (argv[1] == SERIAL_STOP_READING) {
+          byte serialIndexToSkip = 0;
+          if (serialIndex <= 0) {
+            serialIndex = -1;
+          } else {
+            for (byte i = 0; i < serialIndex + 1; i++) {
+              if (reportSerial[i] == portId) {
+                serialIndexToSkip = i;
+                break;
+              }
+            }
+            // shift elements over to fill space left by removed element
+            for (byte i = serialIndexToSkip; i < serialIndex + 1; i++) {
+              if (i < MAX_SERIAL_PORTS) {
+                reportSerial[i] = reportSerial[i + 1];
+              }
+            }
+            serialIndex--;
+          }
+        }
+        break; // SERIAL_READ
+      case SERIAL_CLOSE:
+        serialPort = getPortFromId(portId);
+        if (serialPort != NULL) {
+          if (portId < 8) {
+            ((HardwareSerial*)serialPort)->end();
+          } else {
+#if defined(SoftwareSerial_h)
+            ((SoftwareSerial*)serialPort)->end();
+            if (serialPort != NULL) {
+              free(serialPort);
+              serialPort = NULL;
+            }
+#endif
+          }
+        }
+        break; // SERIAL_CLOSE
+      case SERIAL_FLUSH:
+        serialPort = getPortFromId(portId);
+        if (serialPort != NULL) {
+          getPortFromId(portId)->flush();
+        }
+        break; // SERIAL_FLUSH
+#if defined(SoftwareSerial_h)
+      case SERIAL_LISTEN:
+        // can only call listen() on software serial ports
+        if (portId > 7) {
+          serialPort = getPortFromId(portId);
+          if (serialPort != NULL) {
+            ((SoftwareSerial*)serialPort)->listen();
+          }
+        }
+        break; // SERIAL_LISTEN
+#endif
+    } // end switch
+    return true;
+  }
+  return false;
+}
+
+void SerialFirmata::update()
+{
+  checkSerial();
+}
+
+void SerialFirmata::reset()
+{
+#if defined(SoftwareSerial_h)
+  Stream *serialPort;
+  // free memory allocated for SoftwareSerial ports
+  for (byte i = SW_SERIAL0; i < SW_SERIAL3 + 1; i++) {
+    serialPort = getPortFromId(i);
+    if (serialPort != NULL) {
+      free(serialPort);
+      serialPort = NULL;
+    }
+  }
+#endif
+
+  serialIndex = -1;
+  for (byte i = 0; i < SERIAL_READ_ARR_LEN; i++) {
+    serialBytesToRead[i] = 0;
+  }
+}
+
+// get a pointer to the serial port associated with the specified port id
+Stream* SerialFirmata::getPortFromId(byte portId)
+{
+  switch (portId) {
+    case HW_SERIAL0:
+      // block use of Serial (typically pins 0 and 1) until ability to reclaim Serial is implemented
+      //return &Serial;
+      return NULL;
+#if defined(PIN_SERIAL1_RX)
+    case HW_SERIAL1:
+      return &Serial1;
+#endif
+#if defined(PIN_SERIAL2_RX)
+    case HW_SERIAL2:
+      return &Serial2;
+#endif
+#if defined(PIN_SERIAL3_RX)
+    case HW_SERIAL3:
+      return &Serial3;
+#endif
+#if defined(SoftwareSerial_h)
+    case SW_SERIAL0:
+      if (swSerial0 != NULL) {
+        // instances of SoftwareSerial are already pointers so simply return the instance
+        return swSerial0;
+      }
+      break;
+    case SW_SERIAL1:
+      if (swSerial1 != NULL) {
+        return swSerial1;
+      }
+      break;
+    case SW_SERIAL2:
+      if (swSerial2 != NULL) {
+        return swSerial2;
+      }
+      break;
+    case SW_SERIAL3:
+      if (swSerial3 != NULL) {
+        return swSerial3;
+      }
+      break;
+#endif
+  }
+  return NULL;
+}
+
+// Check serial ports that have READ_CONTINUOUS mode set and relay any data
+// for each port to the device attached to that port.
+void SerialFirmata::checkSerial()
+{
+  byte portId, serialData;
+  int bytesToRead = 0;
+  int numBytesToRead = 0;
+  Stream* serialPort;
+
+  if (serialIndex > -1) {
+
+    // loop through all reporting (READ_CONTINUOUS) serial ports
+    for (byte i = 0; i < serialIndex + 1; i++) {
+      portId = reportSerial[i];
+      bytesToRead = serialBytesToRead[portId];
+      serialPort = getPortFromId(portId);
+      if (serialPort == NULL) {
+        continue;
+      }
+#if defined(SoftwareSerial_h)
+      // only the SoftwareSerial port that is "listening" can read data
+      if (portId > 7 && !((SoftwareSerial*)serialPort)->isListening()) {
+        continue;
+      }
+#endif
+      if (serialPort->available() > 0) {
+        Firmata.write(START_SYSEX);
+        Firmata.write(SERIAL_MESSAGE);
+        Firmata.write(SERIAL_REPLY | portId);
+
+        if (bytesToRead == 0 || (serialPort->available() <= bytesToRead)) {
+          numBytesToRead = serialPort->available();
+        } else {
+          numBytesToRead = bytesToRead;
+        }
+
+        // relay serial data to the serial device
+        while (numBytesToRead > 0) {
+          serialData = serialPort->read();
+          Firmata.write(serialData & 0x7F);
+          Firmata.write((serialData >> 7) & 0x7F);
+          numBytesToRead--;
+        }
+        Firmata.write(END_SYSEX);
+      }
+
+    }
+  }
+}
Index: rtos_arduino/trunk/arduino_lib/libraries/Firmata/utility/SerialFirmata.h
===================================================================
--- rtos_arduino/trunk/arduino_lib/libraries/Firmata/utility/SerialFirmata.h	(revision 224)
+++ rtos_arduino/trunk/arduino_lib/libraries/Firmata/utility/SerialFirmata.h	(revision 224)
@@ -0,0 +1,167 @@
+/*
+  SerialFirmata.h
+  Copyright (C) 2016 Jeff Hoefs. All rights reserved.
+
+  This library is free software; you can redistribute it and/or
+  modify it under the terms of the GNU Lesser General Public
+  License as published by the Free Software Foundation; either
+  version 2.1 of the License, or (at your option) any later version.
+
+  See file LICENSE.txt for further informations on licensing terms.
+
+  This version of SerialFirmata.h differs from the ConfigurableFirmata
+  version in the following ways:
+
+  - Defines FIRMATA_SERIAL_FEATURE (could add to Configurable version as well)
+  - Imports Firmata.h rather than ConfigurableFirmata.h
+
+  Last updated by Jeff Hoefs: January 10th, 2016
+*/
+
+#ifndef SerialFirmata_h
+#define SerialFirmata_h
+
+#include <Firmata.h>
+#include "FirmataFeature.h"
+// SoftwareSerial is currently only supported for AVR-based boards and the Arduino 101
+// The third condition checks if the IDE is in the 1.0.x series, if so, include SoftwareSerial
+// since it should be available to all boards in that IDE.
+#if defined(ARDUINO_ARCH_AVR) || defined(ARDUINO_ARCH_ARC32) || (ARDUINO >= 100 && ARDUINO < 10500)
+#include <SoftwareSerial.h>
+#endif
+
+#define FIRMATA_SERIAL_FEATURE
+
+// Serial port Ids
+#define HW_SERIAL0                  0x00
+#define HW_SERIAL1                  0x01
+#define HW_SERIAL2                  0x02
+#define HW_SERIAL3                  0x03
+// extensible up to 0x07
+
+#define SW_SERIAL0                  0x08
+#define SW_SERIAL1                  0x09
+#define SW_SERIAL2                  0x0A
+#define SW_SERIAL3                  0x0B
+// extensible up to 0x0F
+
+#define SERIAL_PORT_ID_MASK         0x0F
+#define MAX_SERIAL_PORTS            8
+#define SERIAL_READ_ARR_LEN         12
+
+// map configuration query response resolution value to serial pin type
+#define RES_RX1                     0x02
+#define RES_TX1                     0x03
+#define RES_RX2                     0x04
+#define RES_TX2                     0x05
+#define RES_RX3                     0x06
+#define RES_TX3                     0x07
+
+// Serial command bytes
+#define SERIAL_CONFIG               0x10
+#define SERIAL_WRITE                0x20
+#define SERIAL_READ                 0x30
+#define SERIAL_REPLY                0x40
+#define SERIAL_CLOSE                0x50
+#define SERIAL_FLUSH                0x60
+#define SERIAL_LISTEN               0x70
+
+// Serial read modes
+#define SERIAL_READ_CONTINUOUSLY    0x00
+#define SERIAL_STOP_READING         0x01
+#define SERIAL_MODE_MASK            0xF0
+
+namespace {
+
+  struct serial_pins {
+    uint8_t rx;
+    uint8_t tx;
+  };
+
+  /*
+   * Get the serial serial pin type (RX1, TX1, RX2, TX2, etc) for the specified pin.
+   */
+  inline uint8_t getSerialPinType(uint8_t pin) {
+  #if defined(PIN_SERIAL_RX)
+    // TODO when use of HW_SERIAL0 is enabled
+  #endif
+  #if defined(PIN_SERIAL1_RX)
+    if (pin == PIN_SERIAL1_RX) return RES_RX1;
+    if (pin == PIN_SERIAL1_TX) return RES_TX1;
+  #endif
+  #if defined(PIN_SERIAL2_RX)
+    if (pin == PIN_SERIAL2_RX) return RES_RX2;
+    if (pin == PIN_SERIAL2_TX) return RES_TX2;
+  #endif
+  #if defined(PIN_SERIAL3_RX)
+    if (pin == PIN_SERIAL3_RX) return RES_RX3;
+    if (pin == PIN_SERIAL3_TX) return RES_TX3;
+  #endif
+    return 0;
+  }
+
+  /*
+   * Get the RX and TX pins numbers for the specified HW serial port.
+   */
+  inline serial_pins getSerialPinNumbers(uint8_t portId) {
+    serial_pins pins;
+    switch (portId) {
+  #if defined(PIN_SERIAL_RX)
+        // case HW_SERIAL0:
+        //   // TODO when use of HW_SERIAL0 is enabled
+        //   break;
+  #endif
+  #if defined(PIN_SERIAL1_RX)
+      case HW_SERIAL1:
+        pins.rx = PIN_SERIAL1_RX;
+        pins.tx = PIN_SERIAL1_TX;
+        break;
+  #endif
+  #if defined(PIN_SERIAL2_RX)
+      case HW_SERIAL2:
+        pins.rx = PIN_SERIAL2_RX;
+        pins.tx = PIN_SERIAL2_TX;
+        break;
+  #endif
+  #if defined(PIN_SERIAL3_RX)
+      case HW_SERIAL3:
+        pins.rx = PIN_SERIAL3_RX;
+        pins.tx = PIN_SERIAL3_TX;
+        break;
+  #endif
+      default:
+        pins.rx = 0;
+        pins.tx = 0;
+    }
+    return pins;
+  }
+
+} // end namespace
+
+
+class SerialFirmata: public FirmataFeature
+{
+  public:
+    SerialFirmata();
+    boolean handlePinMode(byte pin, int mode);
+    void handleCapability(byte pin);
+    boolean handleSysex(byte command, byte argc, byte* argv);
+    void update();
+    void reset();
+    void checkSerial();
+
+  private:
+    byte reportSerial[MAX_SERIAL_PORTS];
+    int serialBytesToRead[SERIAL_READ_ARR_LEN];
+    signed char serialIndex;
+
+    Stream *swSerial0;
+    Stream *swSerial1;
+    Stream *swSerial2;
+    Stream *swSerial3;
+
+    Stream* getPortFromId(byte portId);
+
+};
+
+#endif /* SerialFirmata_h */
Index: rtos_arduino/trunk/arduino_lib/libraries/Firmata/utility/WiFi101Stream.cpp
===================================================================
--- rtos_arduino/trunk/arduino_lib/libraries/Firmata/utility/WiFi101Stream.cpp	(revision 224)
+++ rtos_arduino/trunk/arduino_lib/libraries/Firmata/utility/WiFi101Stream.cpp	(revision 224)
@@ -0,0 +1,4 @@
+/*
+ * Implementation is in WiFi101Stream.h to avoid linker issues. Legacy WiFi and modern WiFi101 both define WiFiClass which
+ * will cause linker errors whenever Firmata.h is included.
+ */
Index: rtos_arduino/trunk/arduino_lib/libraries/Firmata/utility/WiFi101Stream.h
===================================================================
--- rtos_arduino/trunk/arduino_lib/libraries/Firmata/utility/WiFi101Stream.h	(revision 224)
+++ rtos_arduino/trunk/arduino_lib/libraries/Firmata/utility/WiFi101Stream.h	(revision 224)
@@ -0,0 +1,259 @@
+/*
+  WiFi101Stream.h
+  An Arduino Stream that wraps an instance of a WiFi101 server. For use
+  with Arduino WiFi 101 shield, Arduino MKR1000 and other boards and
+  shields that are compatible with the Arduino WiFi101 library.
+
+  Copyright (C) 2015-2016 Jesse Frush. All rights reserved.
+
+  This library is free software; you can redistribute it and/or
+  modify it under the terms of the GNU Lesser General Public
+  License as published by the Free Software Foundation; either
+  version 2.1 of the License, or (at your option) any later version.
+
+  See file LICENSE.txt for further informations on licensing terms.
+ */
+
+#ifndef WIFI101_STREAM_H
+#define WIFI101_STREAM_H
+
+#include <inttypes.h>
+#include <Stream.h>
+#include <WiFi101.h>
+
+
+class WiFi101Stream : public Stream
+{
+private:
+  WiFiServer _server = WiFiServer(23);
+  WiFiClient _client;
+
+  //configuration members
+  IPAddress _local_ip;
+  uint16_t _port = 0;
+  uint8_t _key_idx = 0;               //WEP
+  const char *_key = nullptr;         //WEP
+  const char *_passphrase = nullptr;  //WPA
+  char *_ssid = nullptr;
+
+  inline int connect_client()
+  {
+    if( !( _client && _client.connected() ) )
+    {
+      WiFiClient newClient = _server.available();
+      if( !newClient )
+      {
+        return 0;
+      }
+
+      _client = newClient;
+    }
+    return 1;
+  }
+
+  inline bool is_ready()
+  {
+    uint8_t status = WiFi.status();
+    return !( status == WL_NO_SHIELD || status == WL_CONNECTED );
+  }
+
+public:
+  WiFi101Stream() {};
+
+  // allows another way to configure a static IP before begin is called
+  inline void config(IPAddress local_ip)
+  {
+    _local_ip = local_ip;
+    WiFi.config( local_ip );
+  }
+
+  // get DCHP IP
+  inline IPAddress localIP()
+  {
+    return WiFi.localIP();
+  }
+
+  inline bool maintain()
+  {
+    if( connect_client() ) return true;
+
+    stop();
+    int result = 0;
+    if( WiFi.status() != WL_CONNECTED )
+    {
+      if( _local_ip )
+      {
+        WiFi.config( _local_ip );
+      }
+
+      if( _passphrase )
+      {
+        result = WiFi.begin( _ssid, _passphrase);
+      }
+      else if( _key_idx && _key )
+      {
+        result = WiFi.begin( _ssid, _key_idx, _key );
+      }
+      else
+      {
+        result = WiFi.begin( _ssid );
+      }
+    }
+    if( result == 0 ) return false;
+
+    _server = WiFiServer( _port );
+    _server.begin();
+    return result;
+  }
+
+/******************************************************************************
+ *           Connection functions with DHCP
+ ******************************************************************************/
+
+  //OPEN networks
+  inline int begin(char *ssid, uint16_t port)
+  {
+    if( !is_ready() ) return 0;
+
+    _ssid = ssid;
+    _port = port;
+    int result = WiFi.begin( ssid );
+    if( result == 0 ) return 0;
+
+    _server = WiFiServer( port );
+    _server.begin();
+    return result;
+  }
+
+  //WEP-encrypted networks
+  inline int begin(char *ssid, uint8_t key_idx, const char *key, uint16_t port)
+  {
+    if( !is_ready() ) return 0;
+
+    _ssid = ssid;
+    _port = port;
+    _key_idx = key_idx;
+    _key = key;
+
+    int result = WiFi.begin( ssid, key_idx, key );
+    if( result == 0 ) return 0;
+
+    _server = WiFiServer( port );
+    _server.begin();
+    return result;
+  }
+
+  //WPA-encrypted networks
+  inline int begin(char *ssid, const char *passphrase, uint16_t port)
+  {
+    if( !is_ready() ) return 0;
+
+    _ssid = ssid;
+    _port = port;
+    _passphrase = passphrase;
+
+    int result = WiFi.begin( ssid, passphrase);
+    if( result == 0 ) return 0;
+
+    _server = WiFiServer( port );
+    _server.begin();
+    return result;
+  }
+
+/******************************************************************************
+ *           Connection functions without DHCP
+ ******************************************************************************/
+
+  //OPEN networks with static IP
+  inline int begin(char *ssid, IPAddress local_ip, uint16_t port)
+  {
+    if( !is_ready() ) return 0;
+
+    _ssid = ssid;
+    _port = port;
+    _local_ip = local_ip;
+
+    WiFi.config( local_ip );
+    int result = WiFi.begin( ssid );
+    if( result == 0 ) return 0;
+
+    _server = WiFiServer( port );
+    _server.begin();
+    return result;
+  }
+
+  //WEP-encrypted networks with static IP
+  inline int begin(char *ssid, IPAddress local_ip, uint8_t key_idx, const char *key, uint16_t port)
+  {
+    if( !is_ready() ) return 0;
+
+    _ssid = ssid;
+    _port = port;
+    _local_ip = local_ip;
+    _key_idx = key_idx;
+    _key = key;
+
+    WiFi.config( local_ip );
+    int result = WiFi.begin( ssid, key_idx, key );
+    if( result == 0 ) return 0;
+
+    _server = WiFiServer( port );
+    _server.begin();
+    return result;
+  }
+
+  //WPA-encrypted networks with static IP
+  inline int begin(char *ssid, IPAddress local_ip, const char *passphrase, uint16_t port)
+  {
+    if( !is_ready() ) return 0;
+
+    _ssid = ssid;
+    _port = port;
+    _local_ip = local_ip;
+    _passphrase = passphrase;
+
+    WiFi.config( local_ip );
+    int result = WiFi.begin( ssid, passphrase);
+    if( result == 0 ) return 0;
+
+    _server = WiFiServer( port );
+    _server.begin();
+    return result;
+  }
+
+/******************************************************************************
+ *             Stream implementations
+ ******************************************************************************/
+
+  inline int available()
+  {
+    return connect_client() ? _client.available() : 0;
+  }
+
+  inline void flush()
+  {
+    if( _client ) _client.flush();
+  }
+
+  inline int peek()
+  {
+    return connect_client() ? _client.peek(): 0;
+  }
+
+  inline int read()
+  {
+    return connect_client() ? _client.read() : -1;
+  }
+
+  inline void stop()
+  {
+    _client.stop();
+  }
+
+  inline size_t write(uint8_t byte)
+  {
+    if( connect_client() ) _client.write( byte );
+  }
+};
+
+#endif //WIFI101_STREAM_H
Index: rtos_arduino/trunk/arduino_lib/libraries/Firmata/utility/WiFiStream.cpp
===================================================================
--- rtos_arduino/trunk/arduino_lib/libraries/Firmata/utility/WiFiStream.cpp	(revision 224)
+++ rtos_arduino/trunk/arduino_lib/libraries/Firmata/utility/WiFiStream.cpp	(revision 224)
@@ -0,0 +1,4 @@
+/*
+ * Implementation is in WiFiStream.h to avoid linker issues. Legacy WiFi and modern WiFi101 both define WiFiClass which
+ * will cause linker errors whenever Firmata.h is included.
+ */
Index: rtos_arduino/trunk/arduino_lib/libraries/Firmata/utility/WiFiStream.h
===================================================================
--- rtos_arduino/trunk/arduino_lib/libraries/Firmata/utility/WiFiStream.h	(revision 224)
+++ rtos_arduino/trunk/arduino_lib/libraries/Firmata/utility/WiFiStream.h	(revision 224)
@@ -0,0 +1,258 @@
+/*
+  WiFiStream.h
+  An Arduino Stream that wraps an instance of a WiFi server. For use
+  with legacy Arduino WiFi shield and other boards and sheilds that
+  are compatible with the Arduino WiFi library.
+
+  Copyright (C) 2015-2016 Jesse Frush. All rights reserved.
+
+  This library is free software; you can redistribute it and/or
+  modify it under the terms of the GNU Lesser General Public
+  License as published by the Free Software Foundation; either
+  version 2.1 of the License, or (at your option) any later version.
+
+  See file LICENSE.txt for further informations on licensing terms.
+ */
+
+#ifndef WIFI_STREAM_H
+#define WIFI_STREAM_H
+
+#include <inttypes.h>
+#include <Stream.h>
+#include <WiFi.h>
+
+class WiFiStream : public Stream
+{
+private:
+  WiFiServer _server = WiFiServer(23);
+  WiFiClient _client;
+
+  //configuration members
+  IPAddress _local_ip;
+  uint16_t _port = 0;
+  uint8_t _key_idx = 0;               //WEP
+  const char *_key = nullptr;         //WEP
+  const char *_passphrase = nullptr;  //WPA
+  char *_ssid = nullptr;
+
+  inline int connect_client()
+  {
+    if( !( _client && _client.connected() ) )
+    {
+      WiFiClient newClient = _server.available();
+      if( !newClient )
+      {
+        return 0;
+      }
+
+      _client = newClient;
+    }
+    return 1;
+  }
+
+  inline bool is_ready()
+  {
+    uint8_t status = WiFi.status();
+    return !( status == WL_NO_SHIELD || status == WL_CONNECTED );
+  }
+
+public:
+  WiFiStream() {};
+
+  // allows another way to configure a static IP before begin is called
+  inline void config(IPAddress local_ip)
+  {
+    _local_ip = local_ip;
+    WiFi.config( local_ip );
+  }
+
+  // get DCHP IP
+  inline IPAddress localIP()
+  {
+    return WiFi.localIP();
+  }
+
+  inline bool maintain()
+  {
+    if( connect_client() ) return true;
+
+    stop();
+    int result = 0;
+    if( WiFi.status() != WL_CONNECTED )
+    {
+      if( _local_ip )
+      {
+        WiFi.config( _local_ip );
+      }
+
+      if( _passphrase )
+      {
+        result = WiFi.begin( _ssid, _passphrase);
+      }
+      else if( _key_idx && _key )
+      {
+        result = WiFi.begin( _ssid, _key_idx, _key );
+      }
+      else
+      {
+        result = WiFi.begin( _ssid );
+      }
+    }
+    if( result == 0 ) return false;
+
+    _server = WiFiServer( _port );
+    _server.begin();
+    return result;
+  }
+
+/******************************************************************************
+ *           Connection functions with DHCP
+ ******************************************************************************/
+
+  //OPEN networks
+  inline int begin(char *ssid, uint16_t port)
+  {
+    if( !is_ready() ) return 0;
+
+    _ssid = ssid;
+    _port = port;
+    int result = WiFi.begin( ssid );
+    if( result == 0 ) return 0;
+
+    _server = WiFiServer( port );
+    _server.begin();
+    return result;
+  }
+
+  //WEP-encrypted networks
+  inline int begin(char *ssid, uint8_t key_idx, const char *key, uint16_t port)
+  {
+    if( !is_ready() ) return 0;
+
+    _ssid = ssid;
+    _port = port;
+    _key_idx = key_idx;
+    _key = key;
+
+    int result = WiFi.begin( ssid, key_idx, key );
+    if( result == 0 ) return 0;
+
+    _server = WiFiServer( port );
+    _server.begin();
+    return result;
+  }
+
+  //WPA-encrypted networks
+  inline int begin(char *ssid, const char *passphrase, uint16_t port)
+  {
+    if( !is_ready() ) return 0;
+
+    _ssid = ssid;
+    _port = port;
+    _passphrase = passphrase;
+
+    int result = WiFi.begin( ssid, passphrase);
+    if( result == 0 ) return 0;
+
+    _server = WiFiServer( port );
+    _server.begin();
+    return result;
+  }
+
+/******************************************************************************
+ *           Connection functions without DHCP
+ ******************************************************************************/
+
+  //OPEN networks with static IP
+  inline int begin(char *ssid, IPAddress local_ip, uint16_t port)
+  {
+    if( !is_ready() ) return 0;
+
+    _ssid = ssid;
+    _port = port;
+    _local_ip = local_ip;
+
+    WiFi.config( local_ip );
+    int result = WiFi.begin( ssid );
+    if( result == 0 ) return 0;
+
+    _server = WiFiServer( port );
+    _server.begin();
+    return result;
+  }
+
+  //WEP-encrypted networks with static IP
+  inline int begin(char *ssid, IPAddress local_ip, uint8_t key_idx, const char *key, uint16_t port)
+  {
+    if( !is_ready() ) return 0;
+
+    _ssid = ssid;
+    _port = port;
+    _local_ip = local_ip;
+    _key_idx = key_idx;
+    _key = key;
+
+    WiFi.config( local_ip );
+    int result = WiFi.begin( ssid, key_idx, key );
+    if( result == 0 ) return 0;
+
+    _server = WiFiServer( port );
+    _server.begin();
+    return result;
+  }
+
+  //WPA-encrypted networks with static IP
+  inline int begin(char *ssid, IPAddress local_ip, const char *passphrase, uint16_t port)
+  {
+    if( !is_ready() ) return 0;
+
+    _ssid = ssid;
+    _port = port;
+    _local_ip = local_ip;
+    _passphrase = passphrase;
+
+    WiFi.config( local_ip );
+    int result = WiFi.begin( ssid, passphrase);
+    if( result == 0 ) return 0;
+
+    _server = WiFiServer( port );
+    _server.begin();
+    return result;
+  }
+
+/******************************************************************************
+ *             Stream implementations
+ ******************************************************************************/
+
+  inline int available()
+  {
+    return connect_client() ? _client.available() : 0;
+  }
+
+  inline void flush()
+  {
+    if( _client ) _client.flush();
+  }
+
+  inline int peek()
+  {
+    return connect_client() ? _client.peek(): 0;
+  }
+
+  inline int read()
+  {
+    return connect_client() ? _client.read() : -1;
+  }
+
+  inline void stop()
+  {
+    _client.stop();
+  }
+
+  inline size_t write(uint8_t byte)
+  {
+    if( connect_client() ) _client.write( byte );
+  }
+};
+
+#endif //WIFI_STREAM_H
Index: rtos_arduino/trunk/arduino_lib/libraries/Firmata/utility/firmataDebug.h
===================================================================
--- rtos_arduino/trunk/arduino_lib/libraries/Firmata/utility/firmataDebug.h	(revision 224)
+++ rtos_arduino/trunk/arduino_lib/libraries/Firmata/utility/firmataDebug.h	(revision 224)
@@ -0,0 +1,14 @@
+#ifndef FIRMATA_DEBUG_H
+#define FIRMATA_DEBUG_H
+
+#ifdef SERIAL_DEBUG
+  #define DEBUG_BEGIN(baud) Serial.begin(baud); while(!Serial) {;}
+  #define DEBUG_PRINTLN(x)  Serial.println (x)
+  #define DEBUG_PRINT(x)    Serial.print (x)
+#else
+  #define DEBUG_BEGIN(baud)
+  #define DEBUG_PRINTLN(x)
+  #define DEBUG_PRINT(x)
+#endif
+
+#endif /* FIRMATA_DEBUG_H */
Index: rtos_arduino/trunk/arduino_lib/libraries/LuckyShield/examples/LuckyTest/LuckyTest.ino
===================================================================
--- rtos_arduino/trunk/arduino_lib/libraries/LuckyShield/examples/LuckyTest/LuckyTest.ino	(revision 223)
+++ rtos_arduino/trunk/arduino_lib/libraries/LuckyShield/examples/LuckyTest/LuckyTest.ino	(revision 224)
@@ -79,4 +79,5 @@
 
   //read magnetometer sensor
+  lucky.magnetometer().read();
   Serial.print("Mx: ");
   Serial.print(lucky.magnetometer().x());
Index: rtos_arduino/trunk/arduino_lib/libraries/LuckyShield/src/Lucky.h
===================================================================
--- rtos_arduino/trunk/arduino_lib/libraries/LuckyShield/src/Lucky.h	(revision 223)
+++ rtos_arduino/trunk/arduino_lib/libraries/LuckyShield/src/Lucky.h	(revision 224)
@@ -40,4 +40,8 @@
 #include "Wire.h"
 
+#ifdef __SAM3X8E__
+#define Wire Wire1
+#endif
+
 class Lucky
 {
Index: rtos_arduino/trunk/arduino_lib/libraries/LuckyShield/src/lib/Adafruit_SSD1306.cpp
===================================================================
--- rtos_arduino/trunk/arduino_lib/libraries/LuckyShield/src/lib/Adafruit_SSD1306.cpp	(revision 223)
+++ rtos_arduino/trunk/arduino_lib/libraries/LuckyShield/src/lib/Adafruit_SSD1306.cpp	(revision 224)
@@ -32,4 +32,7 @@
 #include "Adafruit_SSD1306.h"
 
+#ifdef __SAM3X8E__
+#define Wire Wire1
+#endif
 // the memory buffer for the LCD
 
